import numpy as np
import chipwhisperer as cw
import time
import sys
import ni_fgen
import ni_scope
import CW_ASCON_connection as CW_Con
import random
import os
class Test:
  def __init__(self, tag):
    self.CW = CW_Con.CW_ASCON(tag)
    self.nifgen = ni_fgen.NIFgen()
    self.nifgen.check_locked()
    time.sleep(1)
    self.niscope = ni_scope.NIScope(1, 2500000000, 1400000)
    #self.niscope.check_locked()
    self.CW.init_part2()
    return

  def test1(self, key, nonce, a_data, text, Outname):
    while True:
      self.CW.set_data(key, nonce, a_data, text)
      self.CW.execute()
      self.niscope.record(Outname)
      #time.sleep(4.0)
      if self.CW.exec_done():
        break
    Response = self.CW.get_response()
    print("Input    : "+text)
    print("Response : "+Response)
    return Response

  def close(self):
    print("Closing Ports.")
    self.CW.close()
    self.niscope.close()
    self.nifgen.close()
    return

def Record(tag, keys, nonces, a_data, texts, results):
  tS = time.time()
  print(time.asctime())
  T1 = Test(tag)
  print(time.asctime())
  Responses = [""]*len(keys)
  np.save("./temp/keys.npy", keys)
  np.save("./temp/nonces.npy", nonces)
  np.save("./temp/plaintexts.npy", texts)
  np.save("./temp/ciphertags.npy", results)
  for t in range(0, len(keys)):
    print("=======================================")
    Name = "./temp/trace_"+str(t).zfill(4)
    print(Name)
    response = T1.test1(keys[t], nonces[t], a_data[t], texts[t], Name)
    print("Result   : "+results[t])
    print(results[t]==response)
    if results[t]!=response:
      T1.close()
      return 1
    Responses[t]=response
  T1.close()
  np.save("./temp/responses.npy", Responses)
  tE = time.time()
  print(tE-tS)
  return 0

if __name__=='__main__':
  os.system("md temp")
  Keys = []
  Nonces = []
  A_DATA = []
  Plaintexts = []
  Ciphertags = []
  ########################################################
  # T0
  ########################################################
  Keys.append("61ea5a8a5b4ca17f18a2615819acc55a")
  Nonces.append("f79895d8cce4c77d64744d5414eec48e")
  Plaintexts.append("a2fc32507ac945")
  A_DATA.append("")
  Ciphertags.append("4e19eb7647e00359ddb05dacebaf1fbd7bc4216710eca6")
  ########################################################
  # T1
  ########################################################
  Keys.append("d1f7f40093bcf394e3b9074f12f9d8e0")
  Nonces.append("ab6aa37e02ca72b9386a1e2ffb297f7a")
  Plaintexts.append("239cb3b2efc751")
  A_DATA.append("")
  Ciphertags.append("c8031b13263fcc2b6a39f041a0c4bceaef41534908a2b3")
  Record("ENC_128", Keys, Nonces, A_DATA, Plaintexts, Ciphertags)
  os.system("rmdir /q/s Record_CPA")
  os.system("ren temp Record_CPA")
